#include <stdlib.h>
#include "dogsbody.h"




void RemoveChar(char c,char *s)
{ int i=0;int j;int n=strlen(s);char d;
  for(j=0;j<n;j++) if ((d=s[j])!=c) s[i++]=d;
  s[i]=0;
}

int textinput( ClientData cd, Tcl_Interp *interp, int argc, char *argv[],char c)
{  
   if(c!=0) RemoveChar(c,argv[2]);
   IC(cd, 1000000, 0, argv[2]);
    
   return TCL_OK;
}

int fileinput( ClientData cd, Tcl_Interp *interp, int argc, char *argv[],char c)
{  int i,j,fd;char s[1010];
   i=sscanf(argv[2],"file%d",&fd);
   if (i<=0) {interp->result="Bad File Descriptor";
                 return TCL_ERROR;};
   
   while((i=read(fd,s,1000))>0) {
   s[i]=0;
   if(c!=0) RemoveChar(c,s);
   IC(cd, 1000000, 0, s);
   };
    
   return TCL_OK;
}

int fileoutput( ClientData cd0, Tcl_Interp *interp, int argc, char *argv[])
{  int i,j,fd;char *nargv[10],s; TkText *cd;
  TkTextLine *linePtr;
   i=sscanf(argv[2],"file%d",&fd);
   if (i<=0) {interp->result="Bad File Descriptor";
                 return TCL_ERROR;};

  cd=(TkText *)cd0;
  linePtr = TkBTreeFindLine(cd->tree, 0);
  while(linePtr!=NULL) {
     write(fd,linePtr->bytes,strlen(linePtr->bytes));
     linePtr=TkBTreeNextLine(linePtr);
     }
  
}



int dofind(ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{ int i,j;int line,ch,line2,ch2;
  if(argc!=5) { interp->result="wrong # args to zg";
  return TCL_ERROR;};
   i=sscanf(argv[3],"%d.%d",&line,&ch);
   if (i<=1) {interp->result="Bad Pos 1 for zg";
                 return TCL_ERROR;};

   i=sscanf(argv[4],"%d.%d",&line2,&ch2);
   if (i<=1) {interp->result="Bad Pos 2 for zg";
                 return TCL_ERROR;};

   findstring(cd,line,ch,line2,ch2,argv[2],&line,&ch);
   sprintf(interp->result,"%d.%d",line,ch);
   return TCL_OK;
}

int doRfind(ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{ int i,j;int line,ch,line2,ch2;
  if(argc!=5) { interp->result="wrong # args to zh";
  return TCL_ERROR;};
   i=sscanf(argv[3],"%d.%d",&line,&ch);
   if (i<=1) {interp->result="Bad Pos 1 for zg";
                 return TCL_ERROR;};

   i=sscanf(argv[4],"%d.%d",&line2,&ch2);
   if (i<=1) {interp->result="Bad Pos 2 for zg";
                 return TCL_ERROR;};

   Rfindstring(cd,line,ch,line2,ch2,argv[2],&line2,&ch2);
   sprintf(interp->result,"%d.%d",line2,ch2);
   return TCL_OK;
}



  
char interpres[201];

ClearInterp(Tcl_Interp *interp)
{ if(interp->freeProc!=NULL) interp->freeProc(interp->result);
  interp->result=interpres;
  interpres[0]=0; }

findstring(ClientData cd0,int line,int ch, int line2,int ch2,char *s,int*where,int *wherec)
{ TkText *cd;
  TkTextLine *linePtr;int i,l0;
  l0=line;
  cd=(TkText *) cd0;
  line--;line2--;
  linePtr = TkBTreeFindLine(cd->tree, line);
  i=instr(s,linePtr->bytes + ch + 1);
  if (i>=0) {*where=++line;*wherec=ch+1+i;return;};  
  while(line<line2) {
     linePtr=TkBTreeNextLine(linePtr);line++;
     i=instr(s,linePtr->bytes);
     if (i>=0) {*where=++line;*wherec=i;return;};
     }
  *where=l0;*wherec=ch;
}

int outstr(char *a,char *b)
/* returns position of last instance of string a in string b, or -1 
 *  if it doesn't occur */
{  int i,n,m;
   if((n=strlen(b)-(m=strlen(a)))<0) return -1;
   for(i=n;i>=0;i--)
      if (streq(&b[i],a,m)) return i;
   return -1;
}




Rfindstring(ClientData cd0,int line,int ch, int line2,int ch2,char *s,int*where,int *wherec)
{ TkText *cd;char *l;
  TkTextLine *linePtr;int i,l0;char c;
  l0=line2;
  cd=(TkText *) cd0;
  line--;line2--;
  linePtr = TkBTreeFindLine(cd->tree, line2);
  l=linePtr->bytes;
  c=l[ch2];
  l[ch2]=0;
  i=outstr(s,l);
  l[ch2]=c;

 if (i>=0) {*where=++line2;*wherec=i;return;};  
  while(line2>line) {
     line2--;
     linePtr=TkBTreeFindLine(cd->tree, line2);
     i=outstr(s,linePtr->bytes);
     if (i>=0) {*where=++line2;*wherec=i;return;};
     }
  *where=l0;*wherec=ch2;
}

int isfromheader(char *t,char *fromaddress)
     {
	int d1=0,d2=0,d3=0,d4=0,d5=0,d6=0;char s1[1000],s2[1000],s3[1000];
	s2[0]=0;s3[0]=0;s1[0]=0;
	if ((strlen(t)<10)||(strlen(t)>195)) return 0;
	d6=sscanf(t,"From %s %s %s %d %d:%d:%d %d",s1,s2,s3,&d1,&d2,&d3,&d4,&d5);
	if (d6!=8) return 0;
	if(instr(s2," MON TUE WED THU FRI SAT SUN")<=0) return 0;
	if(instr(s3," JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC")<=0) return 0; 
	strncpy(fromaddress,s1,195);
	return 1;
     }
int issubjectheader(char *t,char *s)
  {
        int i,j;
         s[0]=0;
         i=sscanf(t,"Subject:%s",s);
         if(i>0)strcpy(s,t+8);
         return (i>0);
  }




int doLoadMail(ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{  int i,j,k;FILE *fp;char s[200],s2[200],s3[600],*s4;int n=0;int ready=0;
   s3[0]=0;
   fp=fopen(argv[2],"r");
   if (fp==NULL) { interp->result="Cannot open mailbox";
                  return TCL_ERROR;
                 };
   k=1;
   while (k) { s[0]=0;
               k=(fgets(s,199,fp)!=NULL);
               if(strlen(s)<3)ready=0;
               if(ready)if(issubjectheader(s,s2)) 
                  {
                   ready=0;s4=s3+strlen(s3);sprintf(s4,"\t%s",s2);
                  };
               if(isfromheader(s,s2)||(!k)) 
                  {
                    ready=1;if(n>0)
                    {
                      RemoveChar('\n',s3);RemoveChar('\r',s3); 
                      j=strlen(s3);s3[j]='\n';s3[j+1]=0;  
                      IC(cd, 1000000, 0, s3);
                    }
                    n++;s2[15]=0;sprintf(s3,"[%d] \t%s ",n,s2);
                  };
              };
   fclose(fp);
   return TCL_OK;
}  



